/*******************************************************************************
********************************************************************************

   COPYRIGHT  2004, Advanced Illumination, Inc. 

   Contains confidential and proprietary information which may not be copied,
   disclosed or used by others except as expressly authorized in writing
   by Advanced Illumination.

   tk_usb.h       External definitions for the TCP PC Client Interface Toolkit functions

   About:         This module contains external definitions for the TCP PC Client Interface
                  Toolkit functions.

   Target:        Win32 Compatible

   Written for:   Advanced Illumination, Inc.
                  24 Peavine Drive
                  Rochester, VT 05767
                  http://advancedillumination.com

   Contacts:      John Thrailkill
                  Phone:  (802) 767-3830
                  FAX:    (802) 767-3831
                  jthrailkill@advill.com

   Written by:    James Piette
                  Microprocessor Designs, Inc.
                  65 Longmeadow Drive
                  PO Box 160
                  Shelburne, VT 05482
                  http://www.updesigns.com

   $Revision: 1 $

--------------------------------------------------------------------------------
   $Log: /Advanced Illumination/Pulsar320/pc_src/MPDH8USB_TCP/tk_tcp.h $
 * 
 * 1     8/15/08 12:24p Jpiet
 * 
 * 
********************************************************************************
*******************************************************************************/
#ifndef _TKTCP_H
#define _TKTCP_H

/* Definitions for common values */
#define TKTCP_BUFFER_LEN         254
#ifdef NOTCP
/* Macro interfaces for all toolkit functions */
#define TKTCP_INIT_M(port, name, num)     NO_ERR
#define TKTCP_VALIDATE_PORT_M(port)       NO_ERR
#define TKTCP_WRITE_M(port, buf, len, timeout) NO_ERR
#define TKTCP_READ_M(port, buf, timeout)  NO_ERR
#define TKTCP_CLEAR_RX_M(port)            NO_ERR
#define TKTCP_GET_REPORT_INFO_M(port, usage, pri)   NO_ERR
#define TKTCP_SET_FEATURE_M(port, feature) NO_ERR
#define TKTCP_GET_STRING_M(port, index, buf, len)   NO_ERR
#define TKTCP_SHUTDOWN_M(port)            NO_ERR
#else
/* Macro interfaces for all toolkit functions */
#define TKTCP_INIT_M(port, name, num)     tktcp_init(port, name, num)
#define TKTCP_VALIDATE_PORT_M(port)       tktcp_validate_port(port)
#define TKTCP_WRITE_M(port, buf, len, timeout) tktcp_write(port, buf, len, timeout)
#define TKTCP_READ_M(port, buf, len, timeout)  tktcp_read(port, buf, len, timeout)
#define TKTCP_CLEAR_RX_M(port)            tktcp_clear_rx(port)
#define TKTCP_GET_REPORT_INFO_M(port, usage, pri)                  \
   tktcp_get_report_info(port, usage, pri)
#define TKTCP_SET_FEATURE_M(port, feature)                         \
   tktcp_set_feature(port, feature)
#define TKTCP_GET_STRING_M(port, index, buf, len)                  \
   tktcp_get_string(port, index, buf, len)
#define TKTCP_SHUTDOWN_M(port)            tktcp_shutdown(port)
#endif

/* Prototypes for all toolkit functions */
ERRCODE_T tktcp_init(UINT8_T port, INT8_T * dev_name, INT8_T * serial_num);
ERRCODE_T tktcp_validate_port(UINT8_T port);
ERRCODE_T tktcp_write(UINT8_T port, UINT8_T * out_buf, UINT16_T len, UINT16_T timeout);
ERRCODE_T tktcp_read(UINT8_T port, UINT8_T * in_buf, UINT16_T len, UINT16_T timeout);
ERRCODE_T tktcp_clear_rx(UINT8_T port);
ERRCODE_T tktcp_get_string(UINT8_T port, UINT16_T index, UINT8_T *buf, UINT16_T len);
ERRCODE_T tktcp_shutdown(UINT8_T port);

#endif /* _TKTIME_H */