﻿Imports System.Windows.Forms

Public Class Settings
    Private connPort As Byte
    Private pulsar As CPulsar2
    Public Sub New(ByRef p_Pulsar As CPulsar2)
        ' This call is required by the Windows Form Designer.
        InitializeComponent()
        pulsar = p_Pulsar
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        'Program settings
        Dim slewRate(1) As Byte
        Dim diffTrigger(1) As Byte
        Dim limit48v As Byte
        Dim disableProt As Byte
        slewRate(0) = SlewChan1.SelectedIndex
        slewRate(1) = SlewChan2.SelectedIndex

        diffTrigger(0) = DiffTrig1Check.Checked
        diffTrigger(1) = DiffTrig2Check.Checked

        limit48v = Limit48VCheck.Checked

        pulsar.SetSettings(slewRate, diffTrigger, limit48v, disableProt)

        MsgBox("Any changes require the controller power to be toggled OFF-ON to apply.")

        '        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        '        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Public Sub New(ByVal cfgPort As Byte)

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        connPort = cfgPort
    End Sub

    Private Sub Settings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Get settings from unit
        Dim errCode As Short
        Dim slewRate(1) As Byte
        Dim diffTrigger(1) As Byte
        Dim limit48v As Byte
        Dim disableProt As Byte
        pulsar.GetSettings(slewRate, diffTrigger, limit48v, disableProt)

        If errCode = 0 Then
            SlewChan1.SelectedIndex = slewRate(0)
            SlewChan2.SelectedIndex = slewRate(1)

            DiffTrig1Check.Checked = diffTrigger(0)
            DiffTrig2Check.Checked = diffTrigger(1)

            Limit48VCheck.Checked = limit48v
        End If

        'Update display with settings
    End Sub

End Class
